<script setup lang="ts">
import { ref } from 'vue'
import { useI18n } from 'vue-i18n'
import { useAppStore } from '../stores/AppStore'
import { invoke } from "@tauri-apps/api/tauri"

// using
const { t } = useI18n({
	messages: {
		en: {
			title: `@:app`,
			text: `Text`,
			list: `List`,
			link: `Link`,
			icons: `Icons`,
			buttons: `Buttons`,
			en: `English`,
			th: `Thai`,
			home: `Home`,
			settings: `Settings`,
			favorite: `Like This`,
			form: `Form`,
			text1: `Text 1`,
			text1Hint: `Hint for Text 1`,
			text2: `Text 2`,
			text2Hint: `Hint for Text 2`,
			submit: `Submit`,
			reset: `Reset`,
			tauri: `Tauri`,
			inputPlaceholder: `Enter a name...`,
		},
		th: {
			title: `@:app`,
			text: `ข้อความ`,
			list: `รายการ`,
			link: `เชื่อมโยง`,
			icons: `ไอคอน`,
			buttons: `ปุ่มกด`,
			en: `อังกฤษ`,
			th: `ไทย`,
			home: `บ้าน`,
			settings: `การตั้งค่า`,
			favorite: `ชอบสิ่งนี้`,
			form: `ฟอร์ม`,
			text1: `ข้อความ 1`,
			text1Hint: `คำแนะนำสำหรับ ข้อความ 1`,
			text2: `ข้อความ 2`,
			text2Hint: `คำแนะนำสำหรับ ข้อความ 2`,
			submit: `ส่งค่า`,
			reset: `เริ่มใหม่`,
			tauri: `ทัวริ`,
			inputPlaceholder: `ใส่ชื่อซักชื่อ...`,
		},
	},
})
const appStore = useAppStore()

// states
const text1 = ref("")
const text2 = ref("Preset text 2")
const name = ref("")
const textFromTauri = ref("")

// ----------------------------------------------------------------------

function onSubmit() {
	console.log(`no things to do`)
}

async function greet(): Promise<void> {
	// Learn more about Tauri commands at https://tauri.app/v1/guides/features/command
	console.log(`tauri: send [${name.value}]`)
	textFromTauri.value = await invoke('greet', { name: name.value })
	console.log(`tauri: receive [${name.value}]`)
}
</script>


<template>
	<AppBox :title="t('title')">
		<Breadcrumbs :path="[
			[t('path.home'), '/']]" />

		<section class="testset">
			<h1>{{ t('text') }}</h1>
			<article>
				<span class="text-base">---- base line ----</span>
				<h1>H1</h1>
				<h2>H2</h2>
				<h3>H3</h3>
				<h4>H4</h4>
				<h5>H5</h5>
				<h6>H6</h6>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('list') }}</h1>
			<article>
				<ul class="none">
					<li>
						<RouterLink class="link" to="#" @click.prevent="appStore.setLocale('en')">
							<img src="../assets/images/locale-en.svg" :alt="t('en')" />
							<span>{{ t('en') }}</span>
						</RouterLink>
					</li>
					<li>
						<RouterLink class="link" to="#" @click.prevent="appStore.setLocale('th')">
							<img src="../assets/images/locale-th.svg" :alt="t('th')" />
							<span>{{ t('th') }}</span>
						</RouterLink>
					</li>
				</ul>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('link') }}</h1>
			<article>
				<RouterLink class="link" to="/test-box">{{ t('path.test-box') }}</RouterLink><br />
				<RouterLink class="link" to="/test-box-shared">{{ t('path.test-box-shared') }}</RouterLink><br />
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('icons') }}</h1>
			<article>
				<span class="material-symbols-outlined">home</span>
				<span class="material-symbols-outlined">settings</span>
				<span class="material-symbols-outlined">favorite</span>
				<span class="material-symbols-outlined">done</span>
				<span class="material-symbols-outlined">cancel</span>
				<span class="material-symbols-outlined">disabled_by_default</span>
				<span class="material-symbols-outlined">info</span>
				<span class="material-symbols-outlined">warning</span>
				<span class="material-symbols-outlined">error</span>
				<span class="material-symbols-outlined">help</span>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('buttons') }}</h1>
			<article>
				<button class="normal">
					<i class="material-symbols-outlined">home</i>
					<span>{{ t('home') }}</span>
				</button>
				<button class="normal">
					<i class="material-symbols-outlined">settings</i>
					<span>{{ t('settings') }}</span>
				</button>
				<button class="normal">
					<i class="material-symbols-outlined">favorite</i>
					<span>{{ t('favorite') }}</span>
				</button>
				<button class="normal" disabled="true" aria-disabled="true">
					<i class="material-symbols-outlined">cancel</i>
					<span>{{ t('favorite') }}</span>
				</button>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('form') }}</h1>
			<article>
				<form @submit.prevent="onSubmit">
					<div>
						<label for="text1">{{ t('text1') }}: </label><br />
						<input id="text1" type="text" :placeholder="t('text1Hint')" v-model="text1" />
					</div>

					<div>
						<label for="text2">{{ t('text2') }}: </label><br />
						<input id="text2" type="text" :placeholder="t('text2Hint')" v-model="text2" />
					</div>

					<div>
						<button type="submit">
							<span>{{ t('submit') }}</span>
						</button>
						<button type="reset">
							<span>{{ t('reset') }}</span>
						</button>
					</div>
				</form>
			</article>
		</section>

		<section class="testset">
			<h1>{{ t('tauri') }}</h1>
			<article>
				<form @submit.prevent="greet">
					<input id="greet-input" v-model="name" :placeholder="t('inputPlaceholder')" />
					<button type="submit">
						<span>{{ t('submit') }}</span>
					</button>
				</form>
			</article>
		</section>
	</AppBox>
</template>
